<?php
 namespace Samo; use Resque\Job as Job; use Resque\Exception\Cancel as ResqueCancelException; class DownloadDocumentJob extends AbstractBackgroundJob implements JobInterface { private $timeout = 59; protected $queue = 'docs.dnl'; protected $workerCount = 10; use JobDocumentsCheckInstallTrait; public function process($args, Job $job) { list($document, $server, $session, $lang) = $args; $_SERVER = array_merge($_SERVER, $server); $_GET['LANG'] = $lang; $_SESSION = $session; $return = []; $url = $document['url']; $tmp = parse_url($url); parse_str($tmp['query'], $get); $page = isset($get['page']) ? $get['page'] : 'cl_refer'; $samo_action = isset($get['samo_action']) ? $get['samo_action'] : 'default_action'; if ($page == 'cl_refer_person' && $samo_action == 'proxy_action') { $page = 'cl_refer'; $samo_action = $get['proxy_action']; } if ($page === 'cl_refer') { $claim = isset($get['CLAIM']) ? $get['CLAIM'] : null; $guid = $document['id']; $this->setTrackingId($guid); if ($claim) { \Samo_Registry::load('cache', '\Samo_Cache'); $model = \Samo_Loader::load_object('\Cl_Refer_Model'); $_GET = ['data' => $get['data'], 'CLAIM' => $claim, 'guid' => $guid, 'LANG' => $lang]; $routes = []; include _ROOT . 'routes.php'; foreach ($routes as &$route) { $route['url'] = '#'; } \Samo_Registry::set('routes', $routes); $messages = []; if (file_exists(_ROOT . 'includes/messages/messages_' . $lang . '.php')) { include _ROOT . 'includes/messages/messages_' . $lang . '.php'; } \Samo_Registry::set('messages', $messages); $model->construct($claim); $res = false; $retry = true; $startTime = time(); while ($retry) { $this->log('before ' . $page . '::' . $samo_action, ['retry' => $retry, 'res' => $res]); switch ($samo_action) { case 'PDF_SAMOTOUR': if (isset($res['job'])) { $_SESSION['external_job'] = $res['job']; } try { $res = $model->getExternalDocument(); } catch (\Exception $e) { $res = ['error' => $e->getMessage()]; } break; case 'DOWNLOAD': case 'REDIRECT': $url = $model->linkedDocument(); if (strpos($url, 'http') === 0) { $this->log('file from internet', ['url' => $url]); $prefix = 'e_doc_' . $claim . '_' . crc32($url); $ext = Samo_Utils::url2ext($url); $cwd = getcwd(); chdir(_ROOT . 'dnl'); $files = glob($prefix . '*.' . $ext); chdir($cwd); if (\is_array($files) && (1 == \count($files))) { $localFile = WWWROOT . 'dnl/' . \Samo_Array::first($files); $res = ['url' => $localFile]; $this->log('file from local cache', ['url' => $url, 'localFile' => $localFile]); } else { if (false !== ($content = file_get_contents($url))) { $this->log('download document', ['url' => $url]); if ($localFile = \Samo_Utils::tempFile($prefix, $ext, $content)) { $this->log('save to file', ['localFile' => $localFile]); $res = ['url' => $localFile]; } else { $res = ['error' => 'Unable to save document']; $this->log('error', $res); $retry = false; } } else { $res = ['error' => 'Unable to get document']; $this->log('error', $res); $retry = false; } } } else { $this->log('file from database', ['localFile' => $url]); $res = ['url' => $url]; } break; } $this->log('after ' . $samo_action, ['retry' => $retry, 'res' => $res]); if (!empty($res['url'])) { $res['url'] = \Samo_Url::parse($res['url']); $retry = false; } else { if (!empty($res['error'])) { $retry = false; } else { if (isset($_SESSION['external_job'])) { $res['job'] = $_SESSION['external_job']; } } } if (!isset($res['guid'])) { $res['guid'] = $guid; } if (time() - $startTime > $this->timeout) { $this->log('timeout', ['retry' => $retry, 'res' => $res]); $retry = false; } } if ($res) { $this->log('finish', ['retry' => $retry, 'res' => $res]); echo json_encode($res); return true; } } } else { $res['error'] = 'Download file manually'; $res['guid'] = $document['id']; $this->log('unsupported module', ['page' => $page, 'samo_action' => $samo_action, 'res' => $res]); echo json_encode($res); return false; } throw new ResqueCancelException(); } } 