<?php
 namespace Samo; use Resque\Job as Job; use Symfony\Component\Process\Process; use Symfony\Component\Process\Exception\RuntimeException; class PackDocumentsJob extends AbstractBackgroundJob implements JobInterface { protected $queue = 'docs.pack'; use JobDocumentsCheckInstallTrait; public function process($args, Job $job) { list($data, $server, $session, $lang) = $args; $documents = $data['docs']; $claim = $data['claim']; $_SERVER = array_merge($_SERVER, $server); $_GET['LANG'] = $lang; $this->log('start'); $_SESSION = $session; $return = []; $subtasks = []; $baseName = sprintf("cl_refer_%d_%d_%s", $claim, $claim, \Samo_Utils::randomString(16)); $this->setTrackingId($baseName); $scheduler = new BackgroundTask(); $scheduler->setLoggerBasename(__CLASS__); foreach ($documents as $document) { $subtasks[] = $scheduler->enqueue('Samo\DownloadDocumentJob', $document); } $this->log('after schedule', ['subtasks' => $subtasks]); $start = time(); $timeout = 30; while (!empty($subtasks) && time() - $start < $timeout) { foreach ($subtasks as $idx => $task) { if (false !== ($result = $scheduler->result($task))) { $return[$idx] = $result; unset($subtasks[$idx]); } } usleep(500000); } $this->log('after schedule', [(time() - $start < $timeout) ? 'subtasks_after_work' : 'subtasks_after_timeout' => $subtasks]); $files = array_map( function ($item) { return isset($item['url']) ? basename($item['url']) : null; }, $return ); $files = array_filter($files); $this->log('fetch filenames', ['dnl_files' => $files]); $files = array_unique($files); $this->log('unique filenames', ['dnl_files' => $files]); $extensions = array_map( function ($item) { return ($item) ? strtolower(pathinfo($item, PATHINFO_EXTENSION)) : null; }, $files ); $this->log('fetch filename extensions', ['dnl_extensions' => $extensions]); $extensions = array_filter($extensions); $extensions = array_unique($extensions); $result = false; if (!empty($extensions)) { $cwd = getcwd(); chdir(_ROOT . 'dnl'); if (1 == \count($extensions) && 'pdf' == reset($extensions)) { $result = $baseName . '.pdf'; $params = $files; array_unshift($params, 'pdfunite'); array_push($params, $result); $process = new Process($params); $process->setTimeout(60); try { $process->run(); $exitCode = $process->getExitCode(); $this->log('pdfunite', ['cmd' => $process->getCommandLine(), 'output' => $process->getOutput(), 'status' => $exitCode]); if ($exitCode != 0) { $result = false; } } catch (RuntimeException $e) { $result = false; } } else { $result = $baseName . '.zip'; $params = $files; array_unshift($params, $result); array_unshift($params, 'a'); array_unshift($params, '7za'); $process = new Process($params); $process->setTimeout(60); try { $process->run(); $exitCode = $process->getExitCode(); $this->log('7za', ['cmd' => $process->getCommandLine(), 'output' => $process->getOutput(), 'status' => $exitCode]); if ($exitCode != 0) { $result = false; } } catch (RuntimeException $e) { $result = false; } } chdir($cwd); } if ($result) { echo json_encode(['result' => array_values($return), 'url' => Samo_Url::route('dnl') . basename($result)]); } else { echo json_encode(['result' => $return]); } return $result ? true : false; } } 